The goal of the article at hand is twofold: First, it aims at reviewing several variants of source location problems in undirected networks and summarizes briefly the existing literature. Second, it extends the state of the art by presenting new theoretical findings (e.g. the matroidal structure of static single covers or new structural results for deficient sets), by proposing new algorithms with improved worst-case running time (e.g. a pseudo-polynomial time algorithm and a related fully polynomial time approximation scheme for static plural covers), and by introducing new model variants (e.g. cover problems in dynamic networks).

The main part of the article is framed by an introduction presenting an in-depth overview of the existing literature with several cross references to related results and by a brief conclusion summarizing the main contribution. The actual contribution is structured into three sections: static single covers, static plural covers, and dynamic single covers.

After introducing the single cover problem in undirected static networks, both the concept and structural properties of (minimal) deficient sets are mentioned. A new proof of an exact greedy solution algorithm to the single cover problem is given, which relies on the matroidal structure of the problem. Finally, a polynomial time algorithm for computing the family of all deficient sets is presented, generalizing an algorithm tackling the case of uniform demands.

The next chapter deals with the plural cover problem, again relying on (minimal) deficient sets. After stating structural and computational properties, the authors restrict the study to tree networks, distinguishing the simultaneous and the non-simultaneous problem. For the non-simultaneous case (i.e. the vertex demands are fulfilled one after the other) with uniform costs, an exact linear time algorithm is introduced. The idea of the algorithm is then used to improve the running time of a known exact solution algorithm for the simultaneous problem (i.e. all vertex demands are fulfilled by one flow) with uniform costs. The improvement results again in a linear time algorithm. Next, a pseudo-polynomial time solution algorithm for simultaneous case with cost bounded by \(F \in {\mathbb {N}}_0\) is introduced. This algorithm is converted into a fully polynomial time approximation scheme for the simultaneous problem on trees.

In the last chapter, dynamic flows in directed networks are presented and two standard approaches for computing maximum dynamic flows are mentioned. Based on maximum dynamic flows, the dynamic single cover problem is introduced. Generalizing the static case, dynamic single covers are characterized based on the new notion of (minimal) dynamic deficient sets. By reducing the decision version of the set-covering problem to the decision version of the dynamic single cover problem, the latter is shown to be NP-complete in the strong sense. Finally, it is shown that the dynamic single cover problem is solvable in polynomial time if the underlying network is a path or a cycle. The same is true for uniform costs if the corresponding set-covering problem is tree like, e.g. if the underlying network of the dynamic static cover problem is a tree. These results on polynomially solvable special cases of the dynamic single cover problem are proven by transforming the problem into a set-covering problem and by resorting to results on the latter.

In summary, the article provides a very comprehensive and intelligible overview of source location problems in undirected networks. The existing literature is appealingly presented and a variety of innovative results relying on diverse mathematical techniques is published. For the static problem, the running time of several existing exact solution algorithms is improved and for interesting new problem versions efficient solution algorithms are introduced. Moreover, the dynamic problem is formulated, and its structure and computational properties are studied. Especially for location problems in dynamic networks, a field with diverse applications, the article therefore provides a good starting point for further research.

One possible future research direction shall be introduced in the following. In many real-world applications, it may not be sufficient to consider one single cost function. Instead, several incommensurable objectives are to be optimized simultaneously. For example, in the context of applying source location problems to find gathering/starting points for a controlled evacuation, these locations might be evaluated with respect to monetary cost, physical suitability, or exposure to a latent threat. Therefore, we suggest a multiple objective extension of source location problems and exemplify this potential field in the context of the static single cover problem (a general introduction to multiple objective programming can be found in Ehrgott 2005).

Following the notation of the article at hand, let \(N=(G,u,d,f)\) be an undirected network. In contrast to the single cover presented in the article, let \(f:V\rightarrow {\mathbb {R}}^{p}, 1 < p \in {\mathbb {N}}\) be a vector-valued cost function. The multiple objective static single cover problem can then be defined as

$$\begin{aligned} \min&\ f(S):=\sum _{s\in S} f_{s}\\ \text {s. t. }&\max _{s\in S} \{ \text {Val}(s,v)\} \ge d_{v}, \quad \forall v \in V\\&S\subseteq V. \end{aligned}$$

Although this formulation literally reads as the single cover problem introduced in the article under discussion, it should be pointed out that costs of covers f(S) are no longer reals but vectors of reals. Accordingly, the notion of optimality of a cover has to be fixed. We follow the so-called concept of Pareto-optimality which is based on the componentwise ordering. For two covers, \(S^1, S^2 \subseteq V\), we define

$$\begin{aligned} f\left( S^1\right) \le f\left( S^2\right) :\Leftrightarrow f\left( S^1\right) _i\le f\left( S^2\right) _i, \quad \forall i= 1, \ldots ,p, \quad \text { but }\quad f\left( S^1\right) \not =f\left( S^2\right) . \end{aligned}$$

The cost of a cover \(f(S^1)\) is dominated by the cost of another cover \(f(S^2)\) if \(f(S^2)\le f(S)^1\). The cost of a cover is called nondominated, if it is not dominated. Analogously, we call a cover S efficient, if f(S) is nondominated. The task of solving the multiple objective static single cover problem can then be understood as finding the set of all nondominated cost vectors of covers and, for each nondominated cost vectors, (at least) one corresponding efficient cover.

A first question with respect to this extension is related to the worst-case size of the set of nondominated costs (in dependence on the coding length of the input of the problem). For many combinatorial optimization problems, the cardinality of this nondominated set is exponential and the resulting problem is then called intractable. Second, the complexity status of this problem should be addressed. Many multiple objective combinatorial optimization problems are NP-hard, even for the case \(p=2\).

One way of dealing with the presence of a cost vector is to scalarize it to one (real-valued) cost component. A common approach is to form a so-called weighted-sum scalarization. Let \(0 < \lambda \in {\mathbb {R}}^{p}\). The weighted-sum scalarization of the multiple objective static single cover problem can be formulated as

$$\begin{aligned} \min&\ \lambda ^{\top }f(S):=\sum _{s\in S} \lambda ^{\top }f_{s}\\ \text {s. t. }&\max _{s\in S} \left\{ \text {Val}(s,v)\right\} \ge d_{v}, \quad \forall v \in V\\&S\subseteq V. \end{aligned}$$

It should be pointed out that this is again a single cover problem and can be solved, e.g. by the dual greedy algorithm mentioned in the article under discussion. It is well known that any cover optimal for the weighted-sum scalarization is efficient for the multiple objective static single cover problem. Conversely, not all efficient covers can be found as an optimal solution of the weighted-sum scalarization. Those which can be found are referred to as supported efficient covers.

It is also well known that the extreme points of the convex hull of the nondominated cost vectors can be obtained with the weighted-sum scalarization. In view of an intractability result, the question about the number of theses nondominated extreme cost vectors arises. For the multiple objective minimal spanning tree problem, Seipp (see Seipp 2013) showed that this number is bounded by a polynomial in the input of the instance. His proof relies on a structural analysis of the set of all possible weights \(W=\{\lambda \in {\mathbb {R}}^{p}: \sum _{i=1}^{p}\lambda _{i} = 1 \wedge \lambda _{i} \ge 0, i = 1, \ldots , p\}\). A closer looks reveals that Seipp’s proof solely utilizes the matroidal structure of spanning trees: after sorting edges, a greedy algorithm consecutively processes edges, checks some property, and, based on the result, decides whether or not an edge is chosen to be part of the solution. In fact, this principal approach builds also the core of the dual greedy algorithm for the single cover problem. Thus, an attempt to transfer Seipp’s approach in order to obtain a similar result suggests itself.

In practical instances, it is often the case that the task of computing all nondominated cost vectors is too time-consuming due to a large number of these vectors. Consequently, computing a subset of covers representing all nondominated covers is an obvious alternative (an overview of such methods can be found e.g. in Ruzika and Wiecek 2005). Quite some research has been dedicated to the question of computing a representation of the nondominated set with provable quality attributes (see, e.g. Sayın 2000). For the cover problem, an approach based on a generalized rectangular structure bounding the nondominated set from below and above seems to be promising (for similar approaches, see Hamacher et al. 2007; Dächert and Klamroth 2013; Boland et al. 2014; Kirlik and Sayın 2014). Such a set of generalized rectangles may be iteratively updated by employing the \(\varepsilon \) -constraint scalarization

$$\begin{aligned} \min&\ f(S)_{k}:=\sum _{s\in S} (f_{s})_{k}\\ \text {s. t. }&\max _{s\in S} \{ \text {Val}(s,v)\} \ge d_{v}, \quad \forall v \in V\\&f(S)_{i} \le \varepsilon _{i}, \quad \forall i\in \{1, \ldots , p\}{\setminus } \{k\}\\&S\subseteq V. \end{aligned}$$

where \(k\in \{1, \ldots , p\}\) is the (scalar-valued) cost objective to be minimized while the remaining objectives are constrained from above. Although these additional knapsack-like constraints alter the combinatorial structure and impose additional challenges to a resolution algorithm of this scalar-valued problem, the \(\varepsilon \)-constraint scalarization is capable of finding also unsupported efficient covers (in contrast to the weighted-sum scalarization). The generalized rectangular structure can then be refined by computing efficient covers via the \(\varepsilon \)-constraint scalarization until some quality level is met.

Although these ideas for studying and tackling multiple objective variants of cover problems are sketched for the static single cover, they may also be starting points for similar questions in the context of plural cover problems and cover problems in dynamic networks.